/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <yokota@netlab.is.tsukuba.ac.jp>
 */

/* This code is derived from X-VFlib's vffuncs.c */

/* Xatm_struct.h */

/*$Id: Xatm_struct.h,v 1.9 1999/09/29 20:10:01 elca Exp $*/

#ifndef _XATM_STRUCT_H
#define _XATM_STRUCT_H

#include "btree.h"

typedef struct {
    CharInfoPtr charInfo;
    char *bitmap;
} CharInfoUnit, *CharInfoUnitPtr;

typedef struct {
    CharInfoUnitPtr unit;
    int n;
    int index;
    int bitmapSize;
} CharInfoPool, *CharInfoPoolPtr;

typedef struct _Xatm_Font {
	FontPtr font; /* ƹ¤Τؤεե */

	int hbits, wbytes;
	double matrix[4]; /* ʸѴ
			     [ m[1] m[3] ]
			     [ m[2] m[4] ]
			   */
	double delta_x, delta_y; /* ʿ԰ư */

	int glyph_byte;  /* 1ʸΥХȿ */ /* gryph par byte */

	char *fontname; /* ݥȥץȥեȤ̾ */

	CharInfoPoolPtr pool;
	BTreePtr btree;

	void (*convert)(
#if NeedNestedPrototypes
		struct _Xatm_Font * /* font */,
		char *              /* p */
#endif
		);
} XatmFont, *XatmFontPtr;


#endif
