/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* util.c */

/* $Id: util.c,v 1.7 1999/09/29 20:07:48 elca Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Xatm.h"

/*#define dprintf(str) fprintf str */
#define dprintf(str) /* */

/* ʸʸΰ㤤̵뤹 strstr() */
char * strcasestr(char *haystack, const char *needle)
{
	char *haystackbuf;
	char *needlebuf;
	int i;
	char *ptr;
	char *ret;

	haystackbuf = strdup(haystack);
	needlebuf = strdup(needle);
	if(haystackbuf == NULL || needlebuf == NULL) {
		free(haystackbuf);
		free(needlebuf);
		return NULL;
	}

	/* change to lower case */
	for(i = 0; haystackbuf[i] != 0; i++) {
		haystackbuf[i] = (char)tolower(haystackbuf[i]);
	}
	for(i = 0; needlebuf[i] != 0; i++) {
		needlebuf[i] = (char)tolower(needlebuf[i]);
	}

	ptr = strstr(haystackbuf, needlebuf);

	if(ptr == NULL) {
		ret = NULL;
	} else {
		ret = (ptr - haystackbuf) + haystack;
	}

	dprintf((stdout, "hay %s->%s, need %s->%s, ret %d\n",
		 haystack, haystackbuf,
		 needle, needlebuf, ret));

	free(haystackbuf);
	free(needlebuf);

	return ret;
}

/****************************************************************
 * fonts.dir ǻꤷե̾ե̾
 *
 * "WadaLab-Mincho-0-8@italic.atm" -> "WadaLab-Mincho-0-8"
 * "WadaLab-Mincho-0-8.atm"        -> "WadaLab-Mincho-0-8"
 *
 * ̤ fontname ˳Ǽ롣餫ώʬΰݤƤ
 * ޥ MAXFONTFILENAMELEN Ȥɤ
 */
int xatm_get_fontname(const char *filename, char *fontname)
{
	char buf[MAXFONTFILENAMELEN];
	char *at_mark;
	char *ext_dot;

	strncpy(buf, filename, MAXFONTFILENAMELEN);

	at_mark = strrchr(buf, '@');
	if(at_mark != NULL) {
		*at_mark = '\0';
		goto success_return;
	}

	ext_dot = strrchr(buf, '.');
	if(ext_dot != NULL) {
		*ext_dot = '\0';
		goto success_return;
	}

	fontname[0] = '\0';
	return BadFontName;

success_return:
	strncpy(fontname, buf, MAXFONTFILENAMELEN);
	return Successful;
}

/****************************************************************
 * fonts.dir ǻꤷե̾ cap ̾
 *
 * "WadaLab-Mincho-0-8@italic.atm" -> "italic"
 * "WadaLab-Mincho-0-8.atm"        -> error
 *
 * ̤ capname ˳Ǽ롣餫ώʬΰݤƤ
 * ޥ MAXFONTFILENAMELEN Ȥɤ
 */
int xatm_get_capname(const char *filename, char *capname)
{
	char buf[MAXFONTFILENAMELEN];
	char *at_mark;
	char *ext_dot;
	char *name_start;
	int len;

	strncpy(buf, filename, MAXFONTFILENAMELEN);

	at_mark = strrchr(buf, '@');
	if(at_mark == NULL) {
		goto error_exit;
	}

	ext_dot = strrchr(buf, '.');
	if(ext_dot == NULL) {
		goto error_exit;
	}

	if (at_mark > ext_dot) {
		goto error_exit;
	}

	name_start = at_mark + 1;
	len = ext_dot - name_start;

	strncpy(capname, name_start, len);
	capname[len] = '\0';

	return Successful;

error_exit:
	capname[0] = '\0';
	return BadFontName;
}

/* end */
